;------------------------------------------------------------------------------
; Integer2ASCII 16-bittisille etumerkittmille kokonaisluvuille
;
;  * Ohjelma laskee luvun digittien mrn ja hajoittaa sitten
;    luvun yksittisiksi digiteiksi ja muuttaa kunkin digitin sit vastaavaksi
;    ASCII-koodiksi.
;
;------------------------------------------------------------------------------

               incdir   "Work:Assembler/include"

;-------------------------------------------------------------------------------
; Macros and stuff...
;-------------------------------------------------------------------------------
LibCall        MACRO
               move.l   \1base,a6
               jsr      \2(a6)
               ENDM

OpenLibrary    equ      -$0228
CloseLibrary   equ      -$019e
Write          equ      -$0030
Output         equ      -$003c

Execbase       equ      4

;------------------------------------------------------------------------------
; Ohjelma alkaa
;------------------------------------------------------------------------------

   section  Koodi,Code

               movem.l  d2-d7/a2-a6,-(sp)

; Avataan kirjastot

               lea      dosnimi,a1
               moveq    #0,d0
               LibCall  Exec,OpenLibrary
               move.l   d0,Dosbase

               LibCall  Dos,Output           ; Tulostusta varten
               move.l   d0,outfile           ;

               moveq    #0,d0
               move.w   #700,d0              ; Tulostettava luku

;------------------------------------------------------------------------------
; Integer2ASCII, kytt rekistereit D0-D3,D7 & A2, konvertoitava luku D0:aan
;------------------------------------------------------------------------------
               moveq    #0,d2
               moveq    #0,d3

; Lasketaan digittien mr

               and.l    #$0000ffff,d0        ; Varmistetaan, ett luku on
                                             ; kork. 16-bittinen
               move.l   d0,d1                ; Lasketaan digittien mr
amdigits       addq.l   #1,d2
               divu.w   #10,d1
               and.l    #$0000ffff,d1
               cmp.w    #0,d1
               bgt.s    amdigits
               move.l   d2,d7                ; Digittien mr-1 D7:n
               subq.l   #1,d7                ; (-1 DBF-kskyn vuoksi)

; Muutetaan annettu 16-bittinen positiivinen kokonaisluku ASCII-versiokseen

               lea      Luku,a2              ; Luvun ASCII-version osoite
dsil           move.l   d0,d1                ; Working copy of D0

               moveq    #1,d3                ; Mritetn 10 potensiin
               move.l   d7,d2                ; digitin jrjestysnumero - 1
potsil         subq.l   #1,d2                ;
               cmp.l    #-1,d2               ;
               ble.s    goon                 ;
               mulu.w   #10,d3               ;
               BRA.s    potsil               ;

goon           move.l   d3,d2                ; Jaetaan muutettava luku
               divu.w   d2,d1                ; yll mritetyll luvulla
               and.l    #$0000ffff,d1        ; Nollataan jakojnns
               divu.w   #10,d1               ; Jaetaan viel 10:ll
               swap     d1                   ; Otetaan jakojnns ja nollataan
               and.l    #$0000ffff,d1        ; muu osa luvusta; jljell on
                                             ; on haettu digit!

               add.l    #'0',d1              ; Listn digittiin 0:n ASCII-koodi
               move.b   d1,(a2)+             ; ja kirjoitetaan digit ASCIIna
               dbf      d7,dsil

               move.b   #10,(a2)             ; Rivinvaihto


; Tulostetaan luku

               lea      Luku,a0
               bsr      Print

;------------------------------------------------------------------------------
; Clean up
;------------------------------------------------------------------------------

CleanUp
               move.l   Dosbase,d0
               beq.s    Pois
               move.l   d0,a1
               LibCall  Exec,CloseLibrary

Pois           movem.l  (sp)+,d2-d7/a2-a6
               clr.l    d0
               rts


;------------------------------------------------------------------------------
; A0:ssa tekstin alkuosoite
;------------------------------------------------------------------------------
Print          move.l   a0,d2
etsi_0         tst.b    (a0)+
               bne.s    etsi_0
               subq.l   #1,a0
               sub.l    d2,a0
               move.l   a0,d3
               move.l   outfile,d1
               LibCall  Dos,Write
               rts

;------------------------------------------------------------------------------
; Vakiot
;------------------------------------------------------------------------------
dosnimi        dc.b  "dos.library",0
               even

;------------------------------------------------------------------------------

   section  Muuttujat,DATA

Dosbase        dc.l  0
outfile        dc.l  0
Luku           dc.b  0,0,0,0,0,0,0

               end
